function stime = getSectionTimes(fid,rf)
%
% operates on individual raw files
%
% 170607 smw
global PARAMS

bpsect = 512;       % bytes per sector
nsprf = 3750;       % number of sections per raw file
stime = zeros(nsprf,1); % pre-allocate section time vector

% skip to start of raw file
status = fseek(fid,PARAMS.head.dirlist(rf,1)*bpsect,'bof'); %#ok<NASGU>
Nsect = PARAMS.head.dirlist(rf,10);
% samplerate = PARAMS.head.samplerate;

ftype = 1;

csector = 0;              % sector count
csection = 0;           % section count

% loop over sectors in raw file
% typically there will be multiple number of sectors (=>8) in ea
% Section, so kinda looping over Sections in integer number of
% sectors
while csector < Nsect
    csection = csection + 1;
    [dv,dcount] = fread(fid,8,'uint8');
    % the following shouldn't be needed except for perhaps last file
    % left over from hrp2xwav on single ftp/usb raw files
    if dcount ~= 8
        disp('*************** EOF - Stopped Writing XWAV *******************')
        disp(['only read ',num2str(dcount),' values for timing header'])
        disp('Since less than 8, must be EOF')
        [msg,errnum] = ferror(fid);
        disp(['msg= ',msg,'  errnum= ',num2str(errnum)])
        break       % break out of while csector
    end
    if ftype == 1
        ticks = (little2big_2byte([dv(8) dv(7)]));
        dnum = datenum([dv(2) dv(1) dv(4) dv(3) dv(6) dv(5)+ 0.001.* ticks]);
    elseif ftype == 2
        ticks = 2^8*dv(7)+ dv(8);
        dnum = datenum([dv(1) dv(2) dv(3) dv(4) dv(5) dv(6)+ 0.001.* ticks]);
    end
    stime(csection) = dnum;
    slen = fread(fid,1,'uint16');   % length in bytes of remaining Section
    fseek(fid,-10,0);       % rewind back to beginning of section
    nrsect = ceil((slen+10-2)/bpsect);
    fseek(fid,nrsect*512,0);    % integer number of sectors for each section
    csector = csector + nrsect;
    
end % end while csector