function [ndir, numXWAVs, rawFileNums] = get_rfNums(infile, dfs, ndir0,j0)

global PARAMS

% calculate the number of raw files from dirlist 
% if the hrp file is truncated or otherwise missing data
% BJT: if hrp image is not the expected size there should be some attention
% grabbing user output
hrp_size = dir(infile);
hrp_size = hrp_size.bytes;
if hrp_size < 512 * PARAMS.head.dirlist(end, 1)
    ndir = 0;
    for i = 1:length(PARAMS.head.dirlist) % Todo: replace with find?
        if 512*PARAMS.head.dirlist(i, 1) < hrp_size
            ndir = ndir + 1;
        else
            break
        end
    end
else
%     ndir = PARAMS.head.nextFile;
    ndir = ndir0;
end

% desired filesize for all generated files
filesize = 1.5*1024^3; 

nrf = ndir-j0+1; % number of raw files to be processed
% loop through each decimation type and determine how many raw files can
% fit into each type of xwav
rawFileNums = zeros(1, length(dfs));
numXWAVs = zeros(1, length(dfs));
for i = 1:length(dfs)
    1;
    
    % if no decimation, just use 30 raw files/xwav
    if dfs(i) == 1
        rawFileNums(i) = 30;
        
    else
        % figure out how big each output file is going to be
        rawFileNums(i) = ceil((filesize * dfs(i)) ...
                       /(PARAMS.nsampPerSect * PARAMS.bitsPerSamp * ...
                       PARAMS.nsectPerRawFile));
                   
       % number of raw files for xwav exceeds the 
       % number of files on the disk
       if nrf < rawFileNums(i)
           rawFileNums(i) = nrf;
       end
    end
    
    % number of xwavs generated for each decimation factor
    numXWAVs(i) = nrf/rawFileNums(i);  
    numXWAVs(i) = ceil(numXWAVs(i));  % total number of XWAVs 
end
% ndir = ndir-1; % for files raw files that are segmented TODO 
end
                    
