function procFun


% todo: really should be storing all pertinent globals in the REMORA struct
profile on;

global PARAMS REMORA

% some gui stuff here, what do you want done? What files? Etc
% keep it as user input for now
PARAMS.proc.hrpFiles = ['SOCAL_T_01_B_disk02.hrp'];
files = PARAMS.proc.hrpFiles;
% files = ['CINMS_B_32_disk02.hrp'];
headerfile = fullfile('G:\SOCAL_T_01_B',  'SOCAL_T_01_B.prm');
% PARAMS.proc.path = 'H:\CINMS_B_32';
PARAMS.proc.path = 'G:\SOCAL_T_01_B\';
ipath = PARAMS.proc.path;
% disks = ['01'; '02'];
disks = ['01'];
dfs = [1, 20, 100]; % decimation factors
opath = { 'E:\170816_BWATests\noFix_df1_20_100\';'E:\170816_BWATests\noFix_df1_20_100\';'E:\170816_BWATests\noFix_df1_20_100\' }; % one for each decimation factor
% dfs = PARAMS.dfs;
% dfs = [1];
ltsas = [0, 0,0]; % boolean values for whether we want to make corresponding ltsas
siteName = 'T';
dpln = '01';
projName = 'SOCAL';
dataID = 'SOCAL_T_01_B'; % todo, again need to find a better way of doing this
fixTimes = true;
PARAMS.dflag = true;
PARAMS.df = dfs;
PARAMS.fromProc = true;
REMORA.hrp.tave = [5, 5,5]; % currently these need to be same size as ltsas boolean array...even if not used
REMORA.hrp.dfreq = [200, 200,5]; % currently these need to be same size as ltsas boolean array...even if not used
% REMORA.hrp.tave = [5,5]; 
% REMORA.hrp.dfreq = [200, 10];
PARAMS.ltsa.ch = 1; % TODO this needs to be an option when making from multichannel data
headblk = 12;
PARAMS.ltsa.ftype = 2; % always coming from HRP data for the purpose of this subroutine

% read in metadata from .hrd/.prm file TODO this is stupid and there should
% be a better way of doing it
read_xwavHDRfile(headerfile,0);

% for each disk being processed
for i = 1:size(files, 1)
    PARAMS.error.csl = 0;
    
    % check to see if there's a list of modified dirlist times
    disk = disks(i, :);
    useMod = 0;
    % todo figure out a way here to just take off the file extenstion
    % also todo - would be easier to check for each disk's before doing
    % anything so that user can step away from program
    modName = sprintf('%s_modifiedDirListTimes.mat', files(i, 1:end-4));
    if exist(fullfile(ipath, modName), 'file') == 2
        % user decision - use changed times?
        useMod = ...
        questdlg(sprintf('Modified directory list times found for disk %s, use?',...
        disk));
    end
    
    % load in directory list times and firmware information
    PARAMS.proc.currHRP = fullfile(ipath, files(i, :));
    filename = PARAMS.proc.currHRP;
    read_rawHARPdir(filename, 0);
    ckFirmware;
    prefix = sprintf('%s_%s_%s_', projName, siteName, dpln);
    
    % make necessary directories 
%     xwavPaths = mk_directories(ipath, disk, dataID, dfs);
    xwavPaths = mk_directories(opath, disk, dataID, dfs);
    
    % replace dirlist with modified one TODO questdlg is stupid and we
    % should make our own BOOLEAN returning gui so this stupid if statement
    % can be collapsed
    % todo: add somethings with PARAMS.proc.bwFix here
    if useMod
        if strcmp(useMod, 'Yes')
            load_modhdrs(fullfile(ipath, modName));
        elseif fixTimes
            fix_dirlistTimes;
        end
    elseif fixTimes
        fix_dirlistTimes;
    end
    
    1;
    
    % if making ltsas, generate their names and initialize ltsa vars
    % specific to the disk we're on
    ltsaNames = init_disk_ltsaparams(disk, dfs, prefix);
    
    % get the number of raw files per xwav
%     [ndir, xwavNums, rfCounts] = get_rfNums(filename, dfs);
%     rfCounts_copy = rfCounts;
    if 1  % for debugging set range of rf
        j0 = 1;
        ndir0 = 300;
    else        
        j0 = 1;
        ndir0 = PARAMS.head.nextFile; 
    end

    [ndir, REMORA.hrp.xwavNums, rfCounts] = get_rfNums(filename, dfs, ndir0);
    REMORA.hrp.rfCounts = rfCounts;
    
    % fods (one for each df)
    fod = zeros(1, length(dfs));

    % open raw files
    fid = fopen(fullfile(ipath, files(i, :)));
    
    % loop over each raw file
    currXWAV = zeros(1, length(dfs)); % current XWAV being generated
    
    for j = j0:ndir 
        
        % raw file operations, skip to start of raw file
        status = fseek(fid,PARAMS.head.dirlist(j,1)*512,'bof');
        if status ~= 0
            disp(['Error - failed fseek to byte ',num2str(PARAMS.head.dirlist(j,1)*512)])
            fclose('all');
            return
        end
        
        % xwav file reading operations
        if ~PARAMS.cflag % non compression, 4 ch
            % loop over sectors in raw file 
            for m = 1:PARAMS.head.dirlist(j, 10)
                fseek(fid, headblk, 0); % skip over header, assume time is good
                if PARAMS.nch == 4
                    data = fread(fid, PARAMS.nsampPerSect,'uint16')-32767;
                else
                    data = fread(fid, PARAMS.nsampPerSect,'int16');
                end
                fseek(fid,PARAMS.tailblk,0);   % skip over tail bytes (=0 for nchan=1, =4 for nchan=4)
            end
        else        % compression
            data = decompressRawHRP(fid,j,PARAMS.ctype);
        end
        
        % loop over each decimation factor
        for k = 1:length(dfs)

            % make new xwav file
            if mod(j-1, rfCounts(k)) == 0
              
                % inc. XWAV # currently making
                currXWAV(k) = currXWAV(k) + 1; 
                
                % close last xwav file
                if currXWAV(k) ~= 1
                    fclose(fod(k));
                end
            
                % first raw file header in XWAV
                fhdr = rfCounts(k) * (currXWAV(k)-1) + 1;
                1;
                
                % create XWAV file name
                date = num2str(PARAMS.head.dirlist(fhdr,2:4),'%02d');
                time = num2str(PARAMS.head.dirlist(fhdr,5:7),'%02d');
                % add df to filename if df not 1
                if dfs(k) ~= 1
                    name = sprintf('%s%s_%s_df%d.x.wav', prefix,date,time,dfs(k));
                else
                    name = sprintf('%s%s_%s.x.wav', prefix,date,time);
                end
                
                % open new xwav
                fod(k) = fopen(fullfile(xwavPaths{1, k}, name), 'w');
                
                % change nrf for the last file if needed
                if currXWAV(k) == REMORA.hrp.xwavNums(k)
                    REMORA.hrp.rfCounts(k) = ndir - j + 1; 
                end
                
                if PARAMS.dflag
                    fprintf('\nFilename: %s \nXWAV file %s out of %s\n', ...
                        name, num2str(currXWAV(k)), num2str(REMORA.hrp.xwavNums(k)));
                end
                
                % write XWAV header info
                write_XWAVhead_modified(fod(k),fhdr,REMORA.hrp.rfCounts(k),k);
            end
             
% this doesn't work right, we're resetting data so not decimating original
% data anymore
%             if dfs(k) ~= 1
%                 data = decimate(data, dfs(k));
%             end
            
%             % finally, write to xwav
%             fwrite(fod(k),data,'int16');
            
            fwrite(fod(k),decimate(data, dfs(k)),'int16');

            % if making ltsas
            if ltsas(k)
                
                % globalize data for access in ltsa subroutines
                PARAMS.proc.data = data;
                PARAMS.proc.df = dfs(k);
                PARAMS.ltsa.rfNum = j;
                
%                 % update ltsa sample rate to suit this decimation factor
%                 PARAMS.ltsa.fs = PARAMS.fs/dfs(k);
%                 PARAMS.ltsa.sampPerAve = PARAMS.ltsa.tave * PARAMS.ltsa.fs;
                
                % if making a new ltsa, start with writing the header
                if j == 1
                    
                    % globalize some more data
%                     PARAMS.ltsa.outdir = xwavPaths{1, k};
%                     PARAMS.ltsa.outfile = ltsaNames{k, :};
%                     PARAMS.ltsa.fod = fopen(fullfile(PARAMS.ltsa.outdir, ...
%                         PARAMS.ltsa.outfile),'w');
%                     
%                     fprintf('\nFilename: %s\n', PARAMS.ltsa.outfile);

                    REMORA.hrp.outdir{k} = xwavPaths{1, k};
                    REMORA.hrp.outfile{k} = ltsaNames{k, :};
                    REMORA.hrp.fod(k) = fopen(fullfile(REMORA.hrp.outdir{k}, ...
                        REMORA.hrp.outfile{k}),'w');
                    
                    fprintf('\nFilename: %s\n', REMORA.hrp.outfile{k});
                    
                    % todo eventually want to pass in the rf numbers from
                    % which this ltsa is being created. For the time being,
                    % it's handled by init_file_ltsaparams
%                     tic
                    init_file_ltsaparams(prefix, ndir, k, 1);
%                     disp('time for init file ltsaparams to run');
%                     toc
                    
%                     tic
                    write_ltsahead;
%                     disp('time for write ltsahead to run');
%                     toc
                end
                
                init_file_ltsaparams(prefix, ndir, k, 0);
%                 tic

                % seek to correct byte in output file
                fseek(REMORA.hrp.fod(k),REMORA.hrp.byteloc{k}(j, 1),'bof');
                
                % loop over number of averages
                for n = 1:REMORA.hrp.nave(k)
                                       
                    % grab correct slice of data for the average
                    ltsa_data = data((n-1)*REMORA.hrp.sampPerAve(k) + 1:n*REMORA.hrp.sampPerAve(k));
                    ltsa_data = double(int16(ltsa_data));
                    
                    calc_ltsa(ltsa_data);
    %                 disp('time for calc ltsa to run');
    %                 toc
                end
            end
            
            
        end
        
        if PARAMS.dflag
           disp(['Raw File : ',num2str(j)])
        end
        
    end
    fclose(fid);
end
fclose('all');

% reset fromProc variable so other triton functions can be used normally
PARAMS = rmfield(PARAMS, 'fromProc');

profile off;
profsave(profile('info'), opath{1});
end

