function rawFileNums = setup_hrpProc(infile, dfs)

global PARAMS

% calculate the number of raw files from dirlist 
% if the hrp file is truncated or otherwise missing data
hrp_size = dir(infile);
hrp_size = hrp_size.bytes;
if hrp_size < 512 * PARAMS.head.dirlist(end, 1)
    ndir = 0;
    for i = 1:length(PARAMS.head.dirlist) % Todo: replace with find?
        if 512*PARAMS.head.dirlist(i, 1) < hrp_size
            ndir = ndir + 1;
        else
            break
        end
    end
else
    ndir = PARAMS.head.nextFile;
end

% desired filesize for all generated files
filesize = 1.5*1024^3; 

% loop through each decimation type and determine how many raw files can
% fit into each type of xwav
rawFileNums = zeros(1, length(dfs));
for i = 1:length(dfs)
    
    % if no decimation, just use 30 raw files/xwav
    if dfs(i) == 1
        rawFileNums(i) = 30;
        
    else
        % figure out how big each output file is going to be
        rawFileNums(i) = floor((filesize * dfs(i)) ...
                       /(PARAMS.nsampPerSect * PARAMS.bitsPerSamp * ...
                       PARAMS.nsectPerRawFile));
                   
       % number of raw files for xwav exceeds the 
       % number of files on the disk
       if ndir < rawFileNums(i)
           rawFileNums(i) = ndir;
       end
    end
end
                    
