function [ odata, csectInfo ] = validateDecompresssion_170724(odata, csectInfo)

nSampPerRF = 15e6; % only applies to 200KHz data
nSectPerRF = 3750; 

    % check for decompression weirdness
    empty_rows = find(all(csectInfo==0,2));
    if ~isempty(find(all(csectInfo==0,2))) % find rows where all zeros, caused by sync losses
        fprintf('Found %d all zero rows\n', length(empty_rows));
        csectInfo(empty_rows,:) = [];
    end

    if size(csectInfo,1) > nSectPerRF
        fprintf('Read in %d sections\n', size(csectInfo,1));
        fprintf('Too many sections read in, truncating to 3750!!\n')
        fprintf('\tRead in %d sections\n',size(csectInfo,1));
        csectInfo = csectInfo(1:nSectPerRF,:);
    elseif size(csectInfo,1) < nSectPerRF && length(odata)== nSampPerRF 
        last_sample = csectInfo(end-1,3); % end-1 because last csection may be a syncloss
        csectInfo(end,:) = [];
        odata(last_sample+1:end) = [];
        fprintf('Read in %d sections\n', size(csectInfo,1));
        fprintf('Too few sections read in, uncompressed data truncated to %d samples\n', last_sample);
    end
        
end

        
        